DECLARE SUB points (output$)
DECLARE SUB VerifyOutput (file$)
DECLARE SUB Overwrite (file$)
DECLARE FUNCTION SeparateNameFromExtension$ (output$)
DECLARE SUB DivideString (a$)
DECLARE SUB Formatter ()
DECLARE FUNCTION Fullspace$ (a$)
DECLARE FUNCTION SeparateOutputFilename$ (file$)
DECLARE SUB InputOutputPath (file$)
DECLARE SUB GiveNameToOutputFile (file$)

' ## CASIO FX880P MEMO FORMATER ###
' ## It Completes CASIO.EXE program
'    Manuel Nacher (c) 1997

   CLEAR

PRINT : PRINT "CAFOR 1.00  Copyright (c) 1997  Manuel Nacher  Dec 8 1997"
PRINT "CASIO FORMATTER.  Makes text friendly visible in FX-880P."
IF COMMAND$ = "" THEN GOTO 250
file$ = COMMAND$

InputOutputPath (file$)
 
IF LTRIM$(output$) = "" THEN GiveNameToOutputFile (file$)

VerifyOutput (output$)

' Open files

ON ERROR GOTO 250

CLOSE #1: OPEN "i", #1, inputt$: CLOSE #2: OPEN "o", #2, output$

PRINT : LOCATE CSRLIN, 1: PRINT "Adding "; UCASE$(output$)

DO
points (output$)
Formatter
LOOP UNTIL EOF(1)
CLOSE #2:  END


250 ' Error messages

    PRINT :
    IF ERR = 53 OR ERR = 64 OR ERR = 76 OR ERR = 81 OR ERR = 75 THEN LOCATE CSRLIN, 1: PRINT "File not found !!!": END
    IF ERR = 77 THEN LOCATE CSRLIN, 1: PRINT "I/O Error !!!": END
    IF ERR = 61 THEN LOCATE CSRLIN, 1: PRINT "Disk full !!!": END
    IF ERR = 70 THEN LOCATE CSRLIN, 1: PRINT "Access denied !!!": END
    IF ERR = 71 THEN LOCATE CSRLIN, 1: PRINT "Disk not ready !!!": END
    IF ERR <> 0 THEN LOCATE CSRLIN, 1: PRINT "Error !!!": END

    PRINT "Usage: CAFOR source-file [destination]": ' Message when CAFOR
                                                    ' is executed without
                                                    ' command line.
    
   END

SUB DivideString (a$)

' Divides text strings higher than 31 characters.

a = LEN(a$)
DO
a = a - 1
v$ = LEFT$(a$, a - 1)
IF MID$(a$, a, 1) = " " AND LEN(v$) <= 31 THEN b$ = Fullspace$(v$):  PRINT #2, b$: a$ = RIGHT$(a$, LEN(a$) - a): a = LEN(a$)
IF LEN(a$) <= 31 THEN a$ = Fullspace$(a$): PRINT #2, a$: EXIT SUB
LOOP UNTIL a = 1
a = 0

DO
IF LEN(a$) <= 31 THEN a$ = Fullspace$(a$): PRINT #2, a$: EXIT SUB
b$ = LEFT$(a$, 31)
PRINT #2, b$
a$ = RIGHT$(a$, LEN(a$) - 31)
LOOP

END SUB

SUB Formatter

' It formats the text

LINE INPUT #1, a$

IF LEN(a$) < 31 THEN b$ = Fullspace$(a$): PRINT #2, b$
IF LEN(a$) > 31 THEN DivideString (a$)
IF LEN(a$) = 31 THEN PRINT #2, a$

END SUB

FUNCTION Fullspace$ (a$)

' Given a text string with less than 31 characters, put spaces until it one
' has a 31 characters length.

a = 31 - LEN(a$)
Fullspace$ = a$ + SPACE$(a)
END FUNCTION

SUB GiveNameToOutputFile (file$)

' This SUB gives an output filename when it's not
' specified in the command line.


SHARED output$
a$ = SeparateNameFromExtension$(SeparateOutputFilename$(file$))
output$ = a$ + ".caf"
END SUB

SUB InputOutputPath (file$)

' This SUB separates input and output paths and filenames
' where the program works.

SHARED inputt$, output$
inputt$ = file$
FOR a = 1 TO LEN(file$)
IF MID$(file$, a, 1) = " " THEN output$ = LTRIM$(RIGHT$(file$, LEN(file$) - a)): inputt$ = (LEFT$(file$, a - 1)): EXIT SUB
NEXT
END SUB

SUB Overwrite (file$)

' Routine that prompt to overwrite.

PRINT
LOCATE CSRLIN, 1: PRINT UCASE$(file$); " already exists. Overwrite (y/n)?"
DO
a$ = INKEY$
IF a$ = "y" OR a$ = "Y" THEN EXIT SUB
IF a$ = "n" OR a$ = "N" THEN END
LOOP

END SUB

SUB points (output$)

' Generates a progress indicator

SHARED berg, cou, zig
zig = zig + 1
IF zig <> 40 THEN EXIT SUB:  ELSE zig = 0
a = LEN(output$) + 7 + 4
IF berg = 40 THEN cou = -1
IF berg = 0 THEN cou = 1
LOCATE CSRLIN - 1, a: PRINT STRING$(berg, ""); SPACE$(40 - berg)
berg = berg + cou

END SUB

FUNCTION SeparateNameFromExtension$ (output$)

' This function separates filename and extension from a
' filename, eg: SeparateNameFromExtension$ ("test.bas")    ---->  test

SeparateNameFromExtension$ = output$
FOR q = LEN(output$) TO 1 STEP -1
IF MID$(output$, q, 1) = "." THEN SeparateNameFromExtension$ = MID$(output$, 1, q - 1): EXIT FUNCTION
NEXT
END FUNCTION

FUNCTION SeparateOutputFilename$ (file$)
' This function given a complete path, e.g:
' c:\dos\test.bas
' Let give us this string:  test.bas
' The function separates filenames from paths

SeparateOutputFilename$ = file$
FOR q = LEN(file$) TO 1 STEP -1
IF MID$(file$, q, 1) = "\" THEN SeparateOutputFilename$ = MID$(file$, q + 1, LEN(file$) - q): EXIT FUNCTION
NEXT

END FUNCTION

SUB VerifyOutput (file$)

' Verifies if the output file already exists.

ON LOCAL ERROR GOTO 10
OPEN "i", #2, file$
10 IF ERR = 53 THEN EXIT SUB
IF ERR = 71 THEN PRINT : LOCATE CSRLIN, 1: PRINT "Disk not ready !!!": END
Overwrite (file$)
CLOSE #2: EXIT SUB

RESUME
END SUB

