DECLARE SUB puntos (salida$)
DECLARE SUB verificasalida (archivo$)
DECLARE SUB Sobreescribe (archivo$)
DECLARE FUNCTION AislaNombredeExtension$ (salida$)
DECLARE SUB Partecadena (a$)
DECLARE SUB Formateador ()
DECLARE FUNCTION Llenaespacio$ (a$)
DECLARE FUNCTION AislaNombreArchivoSalida$ (archivo$)
DECLARE SUB PathEntradaSalida (archivo$)
DECLARE SUB DarNombreArchivoSalida (archivo$)

' ## FORMATEADOR DE MEMOS PARA LA CASIO FX880P ###
' ## Complementa el programa CASIO.EXE
   CLEAR

PRINT : PRINT "CAFOR 1.00  Copyright (c) 1997  Manuel Nacher  Dec 8 1997"
PRINT "CASIO FORMATTER.  Makes text friendly visible in FX-880P."
IF COMMAND$ = "" THEN GOTO 250
archivo$ = COMMAND$

PathEntradaSalida (archivo$)
 
IF LTRIM$(salida$) = "" THEN DarNombreArchivoSalida (archivo$)

verificasalida (salida$)

' Abre los archivos

ON ERROR GOTO 250

CLOSE #1: OPEN "i", #1, entrada$: CLOSE #2: OPEN "o", #2, salida$

PRINT : LOCATE CSRLIN, 1: PRINT "Adding "; UCASE$(salida$)

DO
puntos (salida$)
Formateador
LOOP UNTIL EOF(1)
CLOSE #2:  END


250 ' Mensajes de error

    PRINT :
    IF ERR = 53 OR ERR = 64 OR ERR = 76 OR ERR = 81 OR ERR = 75 THEN LOCATE CSRLIN, 1: PRINT "File not found !!!": END
    IF ERR = 77 THEN LOCATE CSRLIN, 1: PRINT "I/O Error !!!": END
    IF ERR = 61 THEN LOCATE CSRLIN, 1: PRINT "Disk full !!!": END
    IF ERR = 70 THEN LOCATE CSRLIN, 1: PRINT "Access denied !!!": END
    IF ERR = 71 THEN LOCATE CSRLIN, 1: PRINT "Disk not ready !!!": END
    IF ERR <> 0 THEN LOCATE CSRLIN, 1: PRINT "Error !!!": END

    PRINT "Usage: CAFOR source-file [destination]": ' Este mensaje aparece
                                                    ' cuando CAFOR es ejecutado
                                                    ' sin linea de comandos.
    
   END

FUNCTION AislaNombreArchivoSalida$ (archivo$)
' Esta funcin dado un path completo, por ejemplo:
' c:\dos\test.bas
' Nos devuelve la cadena:  capullo.bas
' La funcin sirve por lo tanto para separar
' nombres de archivos de paths

AislaNombreArchivoSalida$ = archivo$
FOR q = LEN(archivo$) TO 1 STEP -1
IF MID$(archivo$, q, 1) = "\" THEN AislaNombreArchivoSalida$ = MID$(archivo$, q + 1, LEN(archivo$) - q): EXIT FUNCTION
NEXT
END FUNCTION

FUNCTION AislaNombredeExtension$ (salida$)

' Separa el nombre del archivo de su extension

AislaNombredeExtension$ = salida$
FOR q = LEN(salida$) TO 1 STEP -1
IF MID$(salida$, q, 1) = "." THEN AislaNombredeExtension$ = MID$(salida$, 1, q - 1): EXIT FUNCTION
NEXT

END FUNCTION

SUB DarNombreArchivoSalida (archivo$)

' Esta SUB trata de dar un nombre de salida
' cuando no lo especificamos en la linea de comandos.

SHARED salida$
a$ = AislaNombredeExtension$(AislaNombreArchivoSalida$(archivo$))
salida$ = a$ + ".caf"
END SUB

SUB Formateador

' Es el distribuidor del formateador.

LINE INPUT #1, a$

IF LEN(a$) < 31 THEN b$ = Llenaespacio$(a$): PRINT #2, b$
IF LEN(a$) > 31 THEN Partecadena (a$)
IF LEN(a$) = 31 THEN PRINT #2, a$

END SUB

FUNCTION Llenaespacio$ (a$)

' Llena con espacios una cadena menor de 31 caracteres
' hasta que esta sea de 31 caracteres

a = 31 - LEN(a$)
Llenaespacio$ = a$ + SPACE$(a)
END FUNCTION

SUB Partecadena (a$)

' Para cadenas mayores de 31 caracteres parte estas
' en palabras y genera varias lineas.

a = LEN(a$)
DO
a = a - 1
v$ = LEFT$(a$, a - 1)
IF MID$(a$, a, 1) = " " AND LEN(v$) <= 31 THEN b$ = Llenaespacio$(v$):  PRINT #2, b$: a$ = RIGHT$(a$, LEN(a$) - a): a = LEN(a$)
IF LEN(a$) <= 31 THEN a$ = Llenaespacio$(a$): PRINT #2, a$: EXIT SUB
LOOP UNTIL a = 1
a = 0

DO
IF LEN(a$) <= 31 THEN a$ = Llenaespacio$(a$): PRINT #2, a$: EXIT SUB
b$ = LEFT$(a$, 31)
PRINT #2, b$
a$ = RIGHT$(a$, LEN(a$) - 31)
LOOP
END SUB

SUB PathEntradaSalida (archivo$)

' Esta SUB saca los nombres y paths de entrada y salida en los
' que el programa ejecuta y guarda los resultados

SHARED entrada$, salida$
entrada$ = archivo$:  ' Esta definicion es valida cuando no se especifica archivo de salida
FOR a = 1 TO LEN(archivo$)
IF MID$(archivo$, a, 1) = " " THEN salida$ = LTRIM$(RIGHT$(archivo$, LEN(archivo$) - a)): entrada$ = (LEFT$(archivo$, a - 1)): EXIT SUB
NEXT
END SUB

SUB puntos (salida$)

' Genera una chorrada de indicador de progreso.

SHARED berg, cou, zig
zig = zig + 1
IF zig <> 40 THEN EXIT SUB:  ELSE zig = 0
a = LEN(salida$) + 7 + 4
IF berg = 40 THEN cou = -1
IF berg = 0 THEN cou = 1
LOCATE CSRLIN - 1, a: PRINT STRING$(berg, ""); SPACE$(40 - berg)
berg = berg + cou
END SUB

SUB Sobreescribe (archivo$)

' Pregunta por la sobreescritura de un archivo

PRINT
LOCATE CSRLIN, 1: PRINT UCASE$(archivo$); " already exists. Overwrite (y/n)?"

DO
a$ = INKEY$
IF a$ = "y" OR a$ = "Y" THEN EXIT SUB
IF a$ = "n" OR a$ = "N" THEN END
LOOP

END SUB

SUB verificasalida (archivo$)

' Verifica si el archivo de salida existe.

ON LOCAL ERROR GOTO 10
OPEN "i", #2, archivo$
10 IF ERR = 53 THEN EXIT SUB
IF ERR = 71 THEN PRINT : LOCATE CSRLIN, 1: PRINT "Disk not ready !!!": END
Sobreescribe (archivo$)
CLOSE #2: EXIT SUB

RESUME
END SUB

